     package vaft.core;

     import java.io.*;
     import java.rmi.*;

     /*********************************************************************
     * <P>
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1998-03-15
     *********************************************************************/

     public class  Peer implements Serializable
     //////////////////////////////////////////////////////////////////////
     // Since untrusted agents will have access to objects of this class,
     // it must remain immutable.
     //////////////////////////////////////////////////////////////////////
     {

     private final String  rmi_server_name;
     private final int     rmi_server_port;
     private final String  rmi_object_name;

     //////////////////////////////////////////////////////////////////////
     // Constructor method
     //////////////////////////////////////////////////////////////////////

     public  Peer (
       String  rmi_server_name,
       int     rmi_server_port,
       String  rmi_object_name )
     //////////////////////////////////////////////////////////////////////
     {
       this.rmi_server_name = rmi_server_name;
       this.rmi_server_port = rmi_server_port;
       this.rmi_object_name = rmi_object_name;
     }

     //////////////////////////////////////////////////////////////////////
     // Access methods
     //////////////////////////////////////////////////////////////////////

     public String  getRmi_server_name ( ) { return rmi_server_name; }
     public int     getRmi_server_port ( ) { return rmi_server_port; }
     public String  getRmi_object_name ( ) { return rmi_object_name; }

     //////////////////////////////////////////////////////////////////////
     // Convenience methods
     //////////////////////////////////////////////////////////////////////

     public HostRemote  getHostRemote ( )
       throws java.net.MalformedURLException,
              NotBoundException,
              RemoteException
     //////////////////////////////////////////////////////////////////////
     {
       String  rmi_url = "//" + rmi_server_name + ":" + rmi_server_port
         + "/" + rmi_object_name;
       return ( HostRemote ) Naming.lookup ( rmi_url );
     }

     public void  host ( Agent  agent )
       throws java.net.MalformedURLException,
              NotBoundException,
              RemoteException
     //////////////////////////////////////////////////////////////////////
     {
       getHostRemote ( ).host ( agent );
     }

     public PeerList  swap ( PeerList  peerList )
       throws java.net.MalformedURLException,
              NotBoundException,
              RemoteException
     //////////////////////////////////////////////////////////////////////
     {
       return getHostRemote ( ).swap ( peerList );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
